function initializeCoreMod() {
	/* Class/Interface */Opcodes = Java.type("org.objectweb.asm.Opcodes");
	/* Class */ASMAPI = Java.type("net.minecraftforge.coremod.api.ASMAPI");

	/* Class */InsnList = Java.type("org.objectweb.asm.tree.InsnList");
	/* Class */LabelNode = Java.type("org.objectweb.asm.tree.LabelNode");

	/* Class */FieldNode = Java.type("org.objectweb.asm.tree.FieldNode");
	/* Class */MethodNode = Java.type("org.objectweb.asm.tree.MethodNode");

	/* Class */AbstractInsnNode = Java.type("org.objectweb.asm.tree.AbstractInsnNode");
	/* Class */InsnNode = Java.type("org.objectweb.asm.tree.InsnNode");
	/* Class */VarInsnNode = Java.type("org.objectweb.asm.tree.VarInsnNode");
	/* Class */FieldInsnNode = Java.type("org.objectweb.asm.tree.FieldInsnNode");
	/* Class */MethodInsnNode = Java.type("org.objectweb.asm.tree.MethodInsnNode");
	/* Class */JumpInsnNode = Java.type("org.objectweb.asm.tree.JumpInsnNode");
	/* Class */TypeInsnNode = Java.type("org.objectweb.asm.tree.TypeInsnNode");

	ACC_PUBLIC = Opcodes.ACC_PUBLIC;

	INVOKESTATIC = Opcodes.INVOKESTATIC;
	INVOKEVIRTUAL = Opcodes.INVOKEVIRTUAL;
	INVOKEINTERFACE = Opcodes.INVOKEINTERFACE;
	INVOKESPECIAL = Opcodes.INVOKESPECIAL;

	ALOAD = Opcodes.ALOAD;
	ILOAD = Opcodes.ILOAD;
	FLOAD = Opcodes.FLOAD;
	DLOAD = Opcodes.DLOAD;

	ISTORE = Opcodes.ISTORE;
	ASTORE = Opcodes.ASTORE;

	RETURN = Opcodes.RETURN;
	ARETURN = Opcodes.ARETURN;
	IRETURN = Opcodes.IRETURN;
	DRETURN = Opcodes.DRETURN;

	NEW = Opcodes.NEW;
	INSTANCEOF = Opcodes.INSTANCEOF;
	CHECKCAST = Opcodes.CHECKCAST;

	ACONST_NULL = Opcodes.ACONST_NULL;
	ICONST_0 = Opcodes.ICONST_0;
	ICONST_1 = Opcodes.ICONST_1;

	IFEQ = Opcodes.IFEQ;
	IFNE = Opcodes.IFNE;
	IFNULL = Opcodes.IFNULL;
	IF_ACMPEQ = Opcodes.IF_ACMPEQ;

	GETFIELD = Opcodes.GETFIELD;
	GETSTATIC = Opcodes.GETSTATIC;

	GOTO = Opcodes.GOTO;

	LABEL = AbstractInsnNode.LABEL;
	METHOD_INSN = AbstractInsnNode.METHOD_INSN;

	var isUnlocked="func_193830_f";
	var getCategory="func_202887_g";
	var rebuildTable="func_199644_c";
	return wrapWithLogging(wrapMethodTransformers({

		'IsUnlockedInjection' : {
			'target' : {
				'type' : "METHOD",
				'class' : 'net.minecraft.item.crafting.RecipeBook',
				"methodName" : isUnlocked,
				"methodDesc" : "(Lnet/minecraft/item/crafting/IRecipe;)Z"
			},
			"transformer" : function(methodNode) {
				injectionIsUnlocked(methodNode.instructions);
				return methodNode;
			}
		},
		'GetCategoryInjection' : {
			'target' : {
				'type' : "METHOD",
				'class' : 'net.minecraft.client.util.ClientRecipeBook',
				"methodName" : getCategory,
				"methodDesc" : "(Lnet/minecraft/item/crafting/IRecipe;)Lnet/minecraft/client/util/RecipeBookCategories;"
			},
			"transformer" : function(methodNode) {
				injectionGetCategory(methodNode.instructions);
				return methodNode;
			}
		},
		'RebuildTableInjection' : {
			'target' : {
				'type' : "METHOD",
				'class' : 'net.minecraft.client.util.ClientRecipeBook',
				"methodName" : rebuildTable,
				"methodDesc" : "()V"
			},
			"transformer" : function(methodNode) {
				injectionRebuildTable(methodNode.instructions);
				return methodNode;
			}
		}
	}));
}

/**
 * rebuildTableの尻にフックを追加
 *
 * @param instructions
 * @returns
 */
function injectionRebuildTable(instructions) {

	// ALOAD 0
	// GETFIELD net/minecraft/client/util/ClientRecipeBook.recipesByCategory : Ljava/util/Map;
	// ALOAD 0
	// GETFIELD net/minecraft/client/util/ClientRecipeBook.allRecipes : Ljava/util/List;
	// INVOKESTATIC com/ruby/meshi/client/gui/recipebook/HiganRecipeBookCategories.postRebuildTable(Ljava/util/Map;Ljava/util/List;)V

	var lastLabel;
	var arrayLength = instructions.size();
	var isReturn=false;
	for (var i = arrayLength - 1; i >= 0; --i) {
		var instruction = instructions.get(i);
		if(!isReturn && instruction.getOpcode() == RETURN){
			isReturn=true;
		}

		if (isReturn) {
			if (instruction.getType() == LABEL) {
				lastLabel = instruction;
				print("Found injection point \"last Label\" " + instruction);
				break;
			}
		}
	}
	if (!lastLabel) {
		throw "Error: Couldn't find injection point \"last Label\"!";
	}

	var recipesByCategory=ASMAPI.mapField("field_197931_e");
	var allRecipes=ASMAPI.mapField("field_197932_f");

	var toInject = new InsnList();

	// LastLabel
	toInject.add(new VarInsnNode(ALOAD, 0));// this
	toInject.add(new FieldInsnNode(GETFIELD, "net/minecraft/client/util/ClientRecipeBook", recipesByCategory, "Ljava/util/Map;"));
	toInject.add(new VarInsnNode(ALOAD, 0));// this
	toInject.add(new FieldInsnNode(GETFIELD, "net/minecraft/client/util/ClientRecipeBook", allRecipes, "Ljava/util/List;"));
	toInject.add(new MethodInsnNode(INVOKESTATIC, "com/ruby/meshi/client/gui/recipebook/HiganRecipeBookCategories", "postRebuildTable", "(Ljava/util/Map;Ljava/util/List;)V", false));

	// Inject instructions
	instructions.insert(lastLabel, toInject);
}

/**
 * getCategory(クソ)
 *
 * @param instructions
 * @returns
 */
function injectionGetCategory(instructions) {

	// L0
	// LINENUMBER 21 L0
	// ALOAD 1
	// INVOKESTATIC com/ruby/meshi/client/gui/recipebook/HiganRecipeBookCategories.isHiganRecipe(Lnet/minecraft/item/crafting/IRecipe;)Z
	// IFEQ L1
	// L2
	// LINENUMBER 22 L2
	// ALOAD 1
	// INVOKESTATIC com/ruby/meshi/client/gui/recipebook/HiganRecipeBookCategories.getCategories(Lnet/minecraft/item/crafting/IRecipe;)Lnet/minecraft/client/util/RecipeBookCategories;
	// ARETURN
	// L1

	var firstLabel;
	var arrayLength = instructions.size();
	for (var i = 0; i < arrayLength; ++i) {
		var instruction = instructions.get(i);
		if (instruction.getType() == LABEL) {
			firstLabel = instruction;
			print("Found injection point \"first Label\" " + instruction);
			break;
		}
	}
	if (!firstLabel) {
		throw "Error: Couldn't find injection point \"first Label\"!";
	}

	var toInject = new InsnList();
	var originalInstructionsLabel = new LabelNode();

	// L0
	toInject.add(new VarInsnNode(ALOAD, 0));// IRecipe
	toInject.add(new MethodInsnNode(INVOKESTATIC, "com/ruby/meshi/client/gui/recipebook/HiganRecipeBookCategories", "isHiganRecipe", "(Lnet/minecraft/item/crafting/IRecipe;)Z", false));
	toInject.add(new JumpInsnNode(IFEQ, originalInstructionsLabel));

	// L2
	toInject.add(new VarInsnNode(ALOAD, 0));// IRecipe
	toInject.add(new MethodInsnNode(INVOKESTATIC, "com/ruby/meshi/client/gui/recipebook/HiganRecipeBookCategories", "getCategorie", "(Lnet/minecraft/item/crafting/IRecipe;)Lnet/minecraft/client/util/RecipeBookCategories;", false));
	toInject.add(new InsnNode(ARETURN));

	// L1
	toInject.add(originalInstructionsLabel);

	// Inject instructions
	instructions.insert(firstLabel, toInject);
}

/**
 * isUnlockedのサーバーサイドをごまかしておかないと面倒なため
 *
 * @param instructions
 * @returns
 */
function injectionIsUnlocked(instructions) {

	// L0
	// LINENUMBER 66 L0
	// ALOAD 1
	// INSTANCEOF com/ruby/meshi/crafting/NonLockRecipe
	// IFEQ L1
	// L2
	// LINENUMBER 67 L2
	// ALOAD 1
	// CHECKCAST com/ruby/meshi/crafting/NonLockRecipe
	// ALOAD 1
	// INVOKEINTERFACE com/ruby/meshi/crafting/NonLockRecipe.isUnlocked(Lnet/minecraft/item/crafting/IRecipe;)Z
	// IRETURN
	// L1

	var firstLabel;
	var arrayLength = instructions.size();
	for (var i = 0; i < arrayLength; ++i) {
		var instruction = instructions.get(i);
		if (instruction.getType() == LABEL) {
			firstLabel = instruction;
			print("Found injection point \"first Label\" " + instruction);
			break;
		}
	}
	if (!firstLabel) {
		throw "Error: Couldn't find injection point \"first Label\"!";
	}

	var toInject = new InsnList();
	var originalInstructionsLabel = new LabelNode();
	// L0
	toInject.add(new VarInsnNode(ALOAD, 1));// IRecipe
	toInject.add(new TypeInsnNode(INSTANCEOF, "com/ruby/meshi/crafting/NonLockRecipe"));
	toInject.add(new JumpInsnNode(IFEQ, originalInstructionsLabel));
	// L2
	toInject.add(new VarInsnNode(ALOAD, 1));// IRecipe
	toInject.add(new TypeInsnNode(CHECKCAST, "com/ruby/meshi/crafting/NonLockRecipe"));
	toInject.add(new VarInsnNode(ALOAD, 1));// (NonLockRecipe)IRecipe
	toInject.add(new MethodInsnNode(INVOKEINTERFACE, "com/ruby/meshi/crafting/NonLockRecipe", "isUnlocked", "(Lnet/minecraft/item/crafting/IRecipe;)Z", true));
	toInject.add(new InsnNode(IRETURN));
	// L1
	toInject.add(originalInstructionsLabel);

	// Inject instructions
	instructions.insert(firstLabel, toInject);
}

function wrapWithLogging(transformersObj) {

	var oldPrint = print;
	// Global variable because makeLoggingTransformerFunction is a separate function (thanks to scoping issues)
	currentPrintTransformer = null;
	print = function(msg) {
		if (currentPrintTransformer)
			msg = "[" + currentPrintTransformer + "]: " + msg;
		oldPrint(msg);
	};

	for ( var transformerObjName in transformersObj) {
		var transformerObj = transformersObj[transformerObjName];

		var transformer = transformerObj["transformer"];
		if (!transformer)
			continue;

		transformerObj["transformer"] = makeLoggingTransformerFunction(transformerObjName, transformer);
	}
	return transformersObj;
}

function makeLoggingTransformerFunction(transformerObjName, transformer) {
	return function(obj) {
		currentPrintTransformer = transformerObjName;
		print("Starting Transform.");
		obj = transformer(obj);
		currentPrintTransformer = null;
		return obj;
	}
}

function wrapMethodTransformers(transformersObj) {
	for ( var transformerObjName in transformersObj) {
		var transformerObj = transformersObj[transformerObjName];

		var target = transformerObj["target"];
		if (!target)
			continue;

		var type = target["type"];
		if (!type || !type.equals("METHOD"))
			continue;

		var clazz = target["class"];
		if (!clazz)
			continue;

		var methodName = target["methodName"];
		if (!methodName)
			continue;

		var mappedMethodName = ASMAPI.mapMethod(methodName);

		var methodDesc = target["methodDesc"];
		if (!methodDesc)
			continue;

		var methodTransformer = transformerObj["transformer"];
		if (!methodTransformer)
			continue;

		var newTransformerObjName = "(Method2ClassTransformerWrapper) " + transformerObjName;
		var newTransformerObj = {
			"target" : {
				"type" : "CLASS",
				"name" : clazz,
			},
			"transformer" : makeClass2MethodTransformerFunction(mappedMethodName, methodDesc, methodTransformer)
		};

		transformersObj[newTransformerObjName] = newTransformerObj;

		delete transformersObj[transformerObjName];
	}
	return transformersObj;
}

function makeClass2MethodTransformerFunction(mappedMethodName, methodDesc, methodTransformer) {
	return function(classNode) {
		var methods = classNode.methods;
		for ( var i in methods) {
			var methodNode = methods[i];
			if (!methodNode.name.equals(mappedMethodName))
				continue;
			if (!methodNode.desc.equals(methodDesc))
				continue;
			methods[i] = methodTransformer(methodNode);
			break;
		}
		return classNode;
	};
}
